/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.c 1087 2015-02-03 01:04:34Z ertl-honda $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СAT91SKYEYEѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "at91skyeye.h"
#include "target_serial.h"
#include <target_syssvc.h>

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block 
{
	void* us_thr;
	void* us_rpr;
	void* us_rcr;
	void* us_csr;
	uint_t intno;
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block 
{
	const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
	intptr_t        exinf;        /* ĥ */
	uint8_t usart_rev_buf;        /* ѥХåե */
	bool_t    openflag;           /* ץѤߥե饰 */
	bool_t    sendflag;           /* ߥ֥͡ե饰 */
	bool_t    getready;           /* ʸ */
	bool_t    putready;           /* ʸǤ */
};

/*
 * ꥢI/OݡȽ֥å
 */
static const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{
		(void*)(USART0_THR),
		(void*)(USART0_RPR),
		(void*)(USART0_RCR),
		(void*)(USART0_CSR),
		(uint_t)(INTNO_SIO_PRC1),
	},
#if TNUM_SIOP >= 2
	{
		(void*)(USART0_THR),
		(void*)(USART0_RPR),
		(void*)(USART0_RCR),
		(void*)(USART0_CSR),
		(uint_t)(INTNO_SIO_PRC2),
	},
#endif /* TNUM_SIOP >= 2 */
#if TNUM_SIOP >= 3
	{
		(void*)(USART0_THR),
		(void*)(USART0_RPR),
		(void*)(USART0_RCR),
		(void*)(USART0_CSR),
		(uint_t)(INTNO_SIO_PRC3),
	},
#endif /* TNUM_SIOP >= 3 */
#if TNUM_PORT >= 4
	{
		(void*)(USART0_THR),
		(void*)(USART0_RPR),
		(void*)(USART0_RCR),
		(void*)(USART0_CSR),
		(uint_t)(INTNO_SIO_PRC4),
	}
#endif /* TNUM_SIOP >= 4 */
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SEC_SERIAL1(static SIOPCB, siopcb1);
#if TNUM_SIOP >= 2
SEC_SERIAL2(static SIOPCB, siopcb2);
#endif /* TNUM_SIOP >= 2 */
#if TNUM_SIOP >= 3
SEC_SERIAL3(static SIOPCB, siopcb3);
#endif /* TNUM_SIOP >= 3 */
#if TNUM_SIOP >= 4
SEC_SERIAL4(static SIOPCB, siopcb4);
#endif /* TNUM_SIOP >= 4 */

static SIOPCB* const p_siopcb_table[TNUM_SIOP] = {
	&siopcb1
#if TNUM_SIOP >= 2
	,&siopcb2
#endif /* TNUM_SIOP >= 2 */
#if TNUM_SIOP >= 3
	,&siopcb3
#endif /* TNUM_SIOP >= 3 */
#if TNUM_SIOP >= 4
	,&siopcb4
#endif /* TNUM_SIOP >= 4 */
};

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (p_siopcb_table[INDEX_SIOP(siopid)])


void
at91skyeye_init_uart(uint_t siopid)
{
	SIOPCB *p_siopcb = get_siopcb(siopid);
      
	/* ǡγǼ襢ɥ쥹 */
	sil_wrw_mem((void *)(USART0_RPR), (uint32_t)(&(p_siopcb->usart_rev_buf)));
	sil_wrw_mem((void *)(USART0_RCR), 0x0001);
}

/*
 * ʸ?
 */ 
Inline bool_t
uart_getready(SIOPCB *p_siopcb)
{
	return(sil_rew_mem((void*)(p_siopcb->p_siopinib->us_rcr)) == 0);
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *p_siopcb)
{
	return(true);
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *p_siopcb)
{
	char c;
     
	c = p_siopcb->usart_rev_buf;
	sil_wrw_mem((void *)(p_siopcb->p_siopinib->us_rpr), (uint32_t)(&(p_siopcb->usart_rev_buf)));
	sil_wrw_mem((void *)(p_siopcb->p_siopinib->us_rcr), 0x0001);
    
	return(c);
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *p_siopcb, uint8_t c)
{
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->us_thr),c);
}

/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *p_siopcb)
{

}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *p_siopcb)
{

}


/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *p_siopcb)
{

}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *p_siopcb)
{

}


/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	uint_t  i = (uint_t)exinf;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	(p_siopcb_table[i])->p_siopinib = &(siopinib_table[i]);
	(p_siopcb_table[i])->openflag = false;
	(p_siopcb_table[i])->sendflag = false;
}

/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
at91skyeye_uart_opn_por(SIOPCB *p_siopcb, intptr_t exinf)
{   
	p_siopcb->exinf = exinf;
	p_siopcb->getready = p_siopcb->putready = false;
	p_siopcb->openflag = true;

	return(p_siopcb);
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB  *p_siopcb = get_siopcb(siopid);
	bool_t    opnflg;
	ER      ercd;
    
	/*
	 *  ץ󤷤ݡȤ뤫opnflgɤǤ
	 */
	opnflg = p_siopcb->openflag;

	/*
	 *  ǥХ¸Υץ
	 */
	at91skyeye_uart_opn_por(p_siopcb, exinf);

	/*
	 *  ꥢI/OߤΥޥ롥
	 */
	if (!opnflg) {
		ercd = ena_int(p_siopcb->p_siopinib->intno);
		assert(ercd == E_OK);
	}
	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	/*
	 *  ǥХ¸Υ
	 */
	p_siopcb->openflag = false;
    
	/*
	 *  ꥢI/Oߤޥ롥
	 */
	dis_int(p_siopcb->p_siopinib->intno);
}


/*
 *  SIOγߥϥɥ
 */
void
sio_handler(void)
{
	SIOPCB *p_siopcb = get_siopcb((x_prc_index() + 1));
	if (uart_getready(p_siopcb)) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		sio_irdy_rcv(p_siopcb->exinf);
	}
	if (uart_putready(p_siopcb)) {
		/*
		 *  ǽХå롼ƤӽФ
		 */
		sio_irdy_snd(p_siopcb->exinf);
	}
}


/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char c)
{    
	if (uart_putready(siopcb)){
		uart_putchar(siopcb, c);
		return(true);
	}
	return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	if (uart_getready(siopcb)) {
		return((int_t)(uint8_t) uart_getchar(siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_enable_send(siopcb);
		break;
	  case SIO_RDY_RCV:
		uart_enable_rcv(siopcb);
		break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_disable_send(siopcb);
		break;
	  case SIO_RDY_RCV:
		uart_disable_rcv(siopcb);
		break;
	}
}
